#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Lime

//---- input parameters 
extern int       period=15;
extern int       method=3;                        
extern int       price=0;        
//---- buffers 
double ExtMapBuffer1[];
double vect[];

//+------------------------------------------------------------------+ 
//| Custom indicator initialization function                         | 
//+------------------------------------------------------------------+ 
int init()
  {
   IndicatorBuffers(2);
   SetIndexBuffer(0, ExtMapBuffer1);
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,2);

   SetIndexBuffer(1, vect);

   IndicatorShortName("HMA("+period+")");
   return(0);
  }
//+------------------------------------------------------------------+ 
//| Custor indicator deinitialization function                       | 
//+------------------------------------------------------------------+ 
int deinit()
  { 
   return(0);
  } 
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double WMA(int pos, int p)
  {
   return(iMA(NULL, 0, p, 0, method, price, pos));
  }
//+------------------------------------------------------------------+ 
//| Custom indicator iteration function                              | 
//+------------------------------------------------------------------+ 
int start()
  {
   int counted_bars=IndicatorCounted();
   int p=MathSqrt(period);
   int limit1=Bars-counted_bars;
   int limit2=limit1;
   if (limit1>1) {
      limit1=Bars-period-1;
      limit2=limit1-p;
   }
   int i;

//----
   for(i=limit1; i >=0; i--) vect[i]=2.0*WMA(i, period/2) - WMA(i, period);

   for(i=limit2; i>=0; i--) ExtMapBuffer1[i]=iMAOnArray(vect, 0, p, 0, method, i);
   
   return(0);
  }
//+------------------------------------------------------------------+ 